<?php

/**
 * My Youtube - A plugin that provide a custom button on editor toolbar to embed
 * video from Youtube
 *  
 * License: GNU GPLv3 (http://www.gnu.org/licenses/gpl-3.0.html)
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB")) {
   die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

$plugins->add_hook('newthread_start', 'my_youtube_edit_start');
$plugins->add_hook('newreply_start', 'my_youtube_edit_start');
$plugins->add_hook('editpost_start', 'my_youtube_edit_start');
$plugins->add_hook('parse_message', 'my_youtube_parse_message');


/**
 * Function which describe plugin information
 *
 * @return array
 */
function my_youtube_info() {
   return array(
      "name"            => "My Youtube",
      "description"     => "A plugin that add custom button on editor toolbar to embed youtube video into a post",
      "website"         => "http://rioastamal.net/mybb/my-youtube/",
      "author"          => "Rio Astamal",
      "authorsite"      => "http://rioastamal.net/",
      "version"         => "1.0",
      "guid"            => "00ae12ac5a32288a6f791a4b675288d1", 
      "compatibility"   => "14*"
   );
}

function my_youtube_activate() { 
}

function my_youtube_deactivate() { 
}

function my_youtube_parse_message($post_message) {
   $replacement = '<object width="$1" height="$2"><param name="movie" value="http://$3/v/$4&hl=en&fs=1"></param><param name="allowFullScreen" value="true"></param><param name="allowscriptaccess" value="always"></param><embed src="http://$3/v/$4&hl=en&fs=1" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="$1" height="$2"></embed></object>';
   $post_message = preg_replace('@\[my\-youtube\s+width=([0-9]+)?\s+height=([0-9]+)?\]http://([^<>\'"]+)/watch\?v=([^<>\'"]+)\[/my\-youtube\]@i', $replacement, $post_message);
}

function my_youtube_edit_start() {
   global $headerinclude;
   
   // print "<pre>";print (htmlentities(print_r($templates->get('headerinclude'), TRUE)));
   $headerinclude .= _my_youtube_inject_javascript();
}

function _my_youtube_inject_javascript() {
   global $mybb, $theme;
   $youtube_logo = $mybb->settings['bburl'] . '/inc/plugins/my_youtube/youtube-logo.png';
   
   // well, i did not find an easy way to adding the button to toolbar so i just positioning it
   // works good in Firefox 3 and Opera 9.6
   $bg = '#c1d2ee';
   if ($theme['editortheme'] == 'Office_2007') {
      $bg = 'transparent url(jscripts/editor_themes/Office_2007/images/ui.gif) no-repeat -105px 0px;';
   }
   $js = '
      <!-- start: My Youtube -->
      <style type="text/css">
         .my-youtube-toolbar {
            position:absolute;
            left: 350px; top: 8px;
            padding: 1px;
            border:1px solid transparent;
            width:40px;height:17px;
            /*z-index:999;*/
            float:left;
         }
         a:hover.my-youtube-toolbar { 
            border: 1px solid #1e90ff; 
            background: ' . $bg . '
         }
      </style>
      <script language="javascript">
         window.onload = function() {
            new Insertion.After("editor_toolbar_container_top", \'<a onclick="my_youtube_add_video()" href="javascript:void(0);" title="Embed Youtube Video" class="my-youtube-toolbar"><img src="' . $youtube_logo . '" alt="Youtube Logo" title="Embed Youtube Video" /></a>\');
         }
         function my_youtube_add_video() {
            var ask_video = prompt("Please enter the video URL, i.e: \nhttp://www.youtube.com/watch?v=xxxxxxxxxxx");
            if (!ask_video)
               return ;
               
            var vid_x = prompt("Please enter the width of the video:", "455");
            if (!vid_x || !isNaN(parseInt(vid_x)))
               vid_x = 425;
               
            var vid_y = prompt("Please enter the height of the video:", "344");
            if (!vid_y || !isNaN(parseInt(vid_y)))
               vid_y = 344;
               
           // clickableEditor should already declared by MyBB
           clickableEditor.performInsert("[my-youtube width=" + vid_x + " height=" + vid_y + "]" + ask_video + "[/my-youtube]", "", true, false);
         }
      </script>
      <!-- end: My Youtube -->
      ';
   return $js;
}

?>
